#include <x/options.H>
#include <x/locale.H>
#include <x/messages.H>

#ifndef N_
#define N_(x) x
#endif

#ifndef NN_
#define NN_(s, p) s, p
#endif

class testtooltip_options {

public:
    x::option::list idm45625082868576; /* Top level option list */

    /* OPTION: width */

    typedef x::option::int_value width_t;

    width_t width;

    /* CONSTRUCTOR */

    testtooltip_options(const x::messagesptr &msgcat=x::messagesptr())
 : idm45625082868576(x::option::list::create()),
        width(width_t::create(0))
    {
        init(msgcat);
    }

    static std::string getoptmsg(const x::messagesptr &msgcat, const char *str)
    {
        return (!msgcat.null() ? msgcat->get(str):str);
    }

    template<typename int_type>
    static std::string getoptmsg(const x::messagesptr &msgcat, const char *singular, const char *plural, int_type value)
    {
        return (!msgcat.null() ? msgcat->get(singular, plural, value): value == 1 ? singular:plural);
    }

    void init(const x::messagesptr &msgcat)
    {

        idm45625082868576->add_option(width, "w", getoptmsg(msgcat, N_("width")), 0, getoptmsg(msgcat, N_("Automated test option")));

        idm45625082868576->addDefaultOptions();
    }

    /* Construct a parser object */

    x::option::parser getParser(const x::const_locale &localeArg=x::locale::base::environment())
    {
        x::option::parser parser(x::option::parser::create(localeArg));

        parser->setOptions(idm45625082868576);

        return parser;
    }

    /* Parse argc/argv as received by main(), return parser object */

    x::option::parser parse(int argc, char **argv,
                            const x::const_locale &localeArg
                               =x::locale::base::environment())
    {
        x::option::parser parser=getParser(localeArg);

        int err=parser->parseArgv(argc, argv);

        if (err == 0) err=parser->validate();

        if (err)
        {
            if (err == x::option::parser::base::err_builtin)
                exit(0);

            std::cerr << parser->errmessage();
	    std::cerr.flush();
            exit(1);
        }

        return parser;  /* Retrieve parser->args, if desired. */
    }
};
